%select orbit

orbitnumber = odin_tomography_orbits;


%Altitude grid to interpolate onto
zgrid = [78.5:0.5:87]'*1e3; %OSIRIS gridpoints
aaogrid = [50:0.5:130]';

%Fields for storing frequency
cloud_0d = zeros(length(zgrid),length(aaogrid));
clouds_both = zeros(length(zgrid),length(aaogrid));
cloud_0d_gas = zeros(length(zgrid),length(aaogrid));
clouds_both_gas = zeros(length(zgrid),length(aaogrid));
noclouds_osiris = zeros(length(zgrid),length(aaogrid));
noclouds_osiris_gas = zeros(length(zgrid),length(aaogrid));
cloud_osiris = zeros(length(zgrid),length(aaogrid));
noclouds_0d = zeros(length(zgrid),length(aaogrid));
noclouds_0d_gas = zeros(length(zgrid),length(aaogrid));
noclouds = zeros(length(zgrid),length(aaogrid));
s_gt10_0d = zeros(length(zgrid),length(aaogrid));
s_gt10_0d_gas = zeros(length(zgrid),length(aaogrid));

% z_meso_osiris = zeros(1,201);
% zmax_osiris = zeros(1,201);


numbers_0d = zeros(length(zgrid),length(aaogrid));
numbers_0d_gas = zeros(length(zgrid),length(aaogrid));
numbers_osiris = zeros(length(zgrid),length(aaogrid));
numbers_noclouds = zeros(length(zgrid),length(aaogrid));
numbers_tot = zeros(length(zgrid),length(aaogrid));
clouds_osiris_and_forming = zeros(length(zgrid),length(aaogrid));
clouds_osiris_and_growing = zeros(length(zgrid),length(aaogrid));
clouds_osiris_and_melting = zeros(length(zgrid),length(aaogrid));
clouds_osiris_and_forbidden = zeros(length(zgrid),length(aaogrid));
imd_0d = zeros(length(zgrid),length(aaogrid));
imd_0d_gas = zeros(length(zgrid),length(aaogrid));
imd_osiris = zeros(length(zgrid),length(aaogrid));

number_with_cloud_0d = 0;
number_with_cloud_osiris = 0;
number_with_cloud_0d_gas = 0;
n = 0;


threshold = 0;%10e-12;
iwc_threshold = 0;%threshold*500;

%load Odin-OSIRIS
O = load(['../OSIRIS/tom_NH10_filt_gauss_B_alpha4.4.mat'])
O.z = O.z + 0.580; %adjust for wrong altitude of data
clear zmax

load('old_orbits.mat')

for i = 1:length(orbitnumber)
    %load Odin-SMR
    filename = dir(['../SMR/' '*' num2str(orbitnumber(i)) '.mat']);
    if size(filename,1) == 1
        SMR = load(['../SMR/' filename.name]);
        if (round(SMR.fmode(1)) == 13) && any(orbitnumber(i)==old_orbits)

            osirisindex = find(O.orbit == orbitnumber(i));

            if ~isnan(osirisindex)                    
                    
                orbitnumber(i)
                i
                %generate empty fields
                osiris_ice = zeros(length(zgrid),length(aaogrid));
                osiris_ice_imd = zeros(length(zgrid),length(aaogrid));
                osiris_beta = zeros(length(zgrid),length(aaogrid));
                
                %extract OSIRIS data
                osiris_ice_numberdensity = squeeze(O.IMD(osirisindex,:,:)*1e-12/18e-3*constants('AVOGADRO')); %ice mass density [kg/m3] (IMD[ng/m3], mh2o = 18e-3 kg/mol)
                osiris_ice_numberdensity(find(isnan(osiris_ice_numberdensity))) = 0;
                osiris_radius = squeeze(O.rm(osirisindex,:,:))*1e-9;
                osiris_radius(find(isnan(osiris_radius))) = 0;
                osiris_particle_density = squeeze(O.N(osirisindex,:,:))*1e6;
                osiris_particle_density(find(isnan(osiris_particle_density))) = 0;
                
                %generate emtpy fields
                Q_ice = zeros(length(zgrid),length(aaogrid));
                Q_tot = zeros(length(zgrid),length(aaogrid));
                osiris_zmax = zeros(1,length(aaogrid));
                
                %Create fields for storing results from model
                m_ice_gas= zeros(length(zgrid),length(aaogrid));
                h2o_ice_gas= zeros(length(zgrid),length(aaogrid));
                t_ice = zeros(length(zgrid),length(aaogrid));
                p_ice = zeros(length(zgrid),length(aaogrid));
                s_ice = zeros(length(zgrid),length(aaogrid));
                h2o_sat = zeros(length(zgrid),length(aaogrid));
                v_ice = zeros(length(zgrid),length(aaogrid));
                m_ice = zeros(length(zgrid),length(aaogrid));
                h2o_ice = zeros(length(zgrid),length(aaogrid));
                ztop = zeros(1,length(aaogrid));
                zmax = zeros(1,length(aaogrid));
                zbot = zeros(1,length(aaogrid));
                zmax_0d_index = zeros(1,length(aaogrid));
                zmax_0d_index_gas = zeros(1,length(aaogrid));
                zmax_osiris_index = zeros(1,length(aaogrid));
                iwc = zeros(1,length(aaogrid));
                iwc_gas = zeros(1,length(aaogrid));
                rc = zeros(length(zgrid),length(aaogrid));
                z_meso = zeros(1,length(aaogrid));
                z_mesodiff = zeros(1,length(aaogrid));
                
                %Run model for each AAO
                for I=1:length(aaogrid)
                    
                    %Interpolate data onto common grid
                    z_smr = SMR.Z(:,find(SMR.aao == aaogrid(I)));
                    lat(I) = SMR.lat(:,find(SMR.aao == aaogrid(I)));
                    lon(I) = SMR.lon(:,find(SMR.aao == aaogrid(I)));
                    pressure(:,I) = interp1(z_smr,SMR.pressure,zgrid);
                    H2O(:,I) = interp2(SMR.aao,z_smr,SMR.H2O,aaogrid(I),zgrid,'linear',0); 
                    T(:,I) = interp2(SMR.aao,z_smr,SMR.T,aaogrid(I),zgrid,'linear',0); 
                    osiris_ice(:,I) = interp2(O.AAO,O.z*1e3,osiris_ice_numberdensity,aaogrid(I),zgrid,'linear',0); %ice number density [#/m3] on SMR grid
                    osiris_beta(:,I) = interp2(O.AAO,O.z*1e3,squeeze(O.beta(osirisindex,:,:,7)),aaogrid(I),zgrid,'linear',0);
                    r_osiris(:,I) = interp2(O.AAO,O.z*1e3,osiris_radius,aaogrid(I),zgrid,'linear',0); 
                    nd_osiris(:,I)= interp2(O.AAO,O.z*1e3,osiris_particle_density,aaogrid(I),zgrid,'linear',0); 
                    osiris_ice_imd(:,I) =  osiris_ice(:,I)*18e-3/constants('AVOGADRO');%ice mass density [kg/m3] on grid
                    [~,osiris_zmax(I)] = max(osiris_ice_imd(:,I));
                    
                    
                    osiris_iwc(I) = trapz(zgrid,osiris_ice_imd(:,I)); % Integrate to get ice column
                    rad(:,I) = ones(1,length(zgrid))*0; %radius of particles = 0
                    
                    %Find low edge of cloud layer
                    osiris_zbot_index = find(osiris_ice_imd(:,I)>0,1);
                    if ~isempty(osiris_zbot_index)
                        osiris_zbot(I) = zgrid(osiris_zbot_index);
                    else
                        osiris_zbot(I) = 0;
                    end
                    
                                       
                    Q_ice(:,I) = nd2vmr(osiris_ice(:,I),pressure(:,I),T(:,I));
                    Q_tot(:,I) = H2O(:,I)+Q_ice(:,I);

                    %Run model with Q_tot
                    [t_ice(:,I),p_ice(:,I),s_ice(:,I),h2o_sat(:,I),v_ice(:,I),m_ice(:,I),...
                        h2o_ice(:,I),ztop(:,I),zmax(:,I),zbot(:,I),iwc(:,I),rc(:,I)] =...
                        pmc_0d_model(zgrid,T(:,I),pressure(:,I),Q_tot(:,I),rad(:,I));
                   
                    %Run model with Q_gas
                    [~,~,~,~,~,m_ice_gas(:,I),...
                        h2o_ice_gas(:,I),~,~,~,iwc_gas(:,I),~] =...
                        pmc_0d_model(zgrid,T(:,I),pressure(:,I),Q_tot(:,I)-Q_ice(:,I),rad(:,I));
                   
                    
                end
                %%%%%%%%%%%%%%%%%%%%%%%
                %Store all the data
                %%%%%%%%%%%%%%%%%%%%%%%%
                n = n+1
                
                orbitnumber_tot(n) = orbitnumber(i);
                T_tot(:,:,n) = T;
                H2O_tot(:,:,n) = H2O;
                pressure_tot(:,:,n) = pressure;
                Q_ice_tot(:,:,n) = Q_ice;
                Q_tot_tot(:,:,n) = Q_tot;
                osiris_ice_imd_tot(:,:,n) = osiris_ice_imd;
                osiris_r_tot(:,:,n) = r_osiris;
                osiris_nd_tot(:,:,n) = nd_osiris;
                osiris_beta_tot(:,:,n) = osiris_beta;
                osiris_iwc_tot(:,:,n) = osiris_iwc;
                osiris_zbot_tot(:,n) = osiris_zbot;
                t_ice_tot(:,:,n) = t_ice;
                p_ice_tot(:,:,n)  = p_ice;
                s_ice_tot(:,:,n)  = s_ice;
                h2o_sat_tot(:,:,n)  = h2o_sat;
                v_ice_tot(:,:,n)  = v_ice;
                m_ice_tot(:,:,n)  = m_ice;
                h2o_ice_tot(:,:,n) = h2o_ice;
                ztop_tot(:,:,n)  = ztop;
                zmax_tot(:,:,n) = zmax;
                zbot_tot(:,:,n) = zbot;
                zmax_0d_index_tot(:,:,n) = zmax_0d_index;
                zmax_0d_index_gas_tot(:,:,n) = zmax_0d_index_gas;
                zmax_osiris_index_tot(:,:,n) = zmax_osiris_index;
                iwc_tot(:,:,n)  = iwc;
                lat_tot_flat(:,:,n) = lat;
                lon_tot_flat(:,:,n) = lon;
                rc_tot(:,:,n)  = rc;
                
                m_ice_gas_tot(:,:,n) = m_ice_gas;
                h2o_ice_gas_tot(:,:,n) = h2o_ice_gas;
                iwc_gas_tot(:,:,n)  = iwc_gas;

                Z_tot(:,:,n) = repmat(zgrid,1,length(aaogrid));
                lat_tot(:,:,n) = repmat(lat,size(H2O,1),1);
                lon_tot(:,:,n) = repmat(lon,size(H2O,1),1);
                mjd_osiris_odin(n) = SMR.mjd(1); %gets same date as first scan in orbit
                aao_tot(:,:,n) = repmat(aaogrid,size(H2O,1),1);
                
                %%%%%%%%%%%%%%%%%%%%%%%
                %Classify the clouds
                %%%%%%%%%%%%%%%%%%%%%%%%
                
                for j = 1:size(H2O,1)
                    for k = 1:size(H2O,2)
                        if m_ice(j,k) > threshold
                            cloud_0d(j,k) = cloud_0d(j,k)+1; %add a cloud from model to give 0d cloud frequency
                            imd_0d(j,k) = imd_0d(j,k) + m_ice(j,k);
                            numbers_0d(j,k) = numbers_0d(j,k)+1;
                            if s_ice(j,k)>10
                                s_gt10_0d(j,k) = s_gt10_0d(j,k) +1;
                            end
                            if osiris_ice_imd(j,k) > threshold %if OSIRIS and 0D model detect
                                clouds_both(j,k) = clouds_both(j,k)+1; 
                            else %if only 0D model detect
                                noclouds_osiris(j,k) = noclouds_osiris(j,k)+1; %
                            end
                            
                        end
                        if m_ice_gas(j,k) > threshold
                            cloud_0d_gas(j,k) = cloud_0d_gas(j,k)+1; %add a cloud from model to give 0d cloud frequency
                            imd_0d_gas(j,k) = imd_0d_gas(j,k) + m_ice_gas(j,k);
                            numbers_0d_gas(j,k) = numbers_0d_gas(j,k)+1;
                            if s_ice(j,k)>10
                                s_gt10_0d_gas(j,k) = s_gt10_0d_gas(j,k) +1;
                            end
                            if osiris_ice_imd(j,k) > threshold %if OSIRIS and 0D model detect
                                clouds_both_gas(j,k) = clouds_both_gas(j,k)+1; 
                            else %if only 0D model detect
                                noclouds_osiris_gas(j,k) = noclouds_osiris_gas(j,k)+1; %
                            end
                            
                        end
                        if osiris_ice_imd(j,k)> threshold %if osiris detects
                            cloud_osiris(j,k) = cloud_osiris(j,k)+1; %get osiris cloud frequency
                            numbers_osiris(j,k) = numbers_osiris(j,k)+1;     
                            imd_osiris(j,k) = imd_osiris(j,k)+osiris_ice_imd(j,k);
                            if m_ice_gas(j,k) > threshold %cloud is growing
                                clouds_osiris_and_growing(j,k) = clouds_osiris_and_growing(j,k) +1;
                            elseif m_ice(j,k) > threshold %Qice + Qgas > Qsat but Qgas < Sat -> Clouds is melting
                                clouds_osiris_and_melting(j,k) = clouds_osiris_and_melting(j,k) +1;
                            elseif m_ice(j,k) <= threshold %Qice + Qgas > Qsat but Qgas < Sat -> Clouds is melting
                                clouds_osiris_and_forbidden(j,k) = clouds_osiris_and_forbidden(j,k) +1;
                            else %if only OSIRIS model detect
                                error('not valid cloud condition')
                            end
                        end
                        if osiris_ice_imd(j,k)<threshold && m_ice(j,k)<threshold %if no clouds
                            noclouds(j,k) = noclouds(j,k) +1;
                            numbers_noclouds(j,k) = numbers_noclouds(j,k) + 1;
                        end
                        numbers_tot(j,k) = numbers_tot(j,k) +1; %total number of measurements
                        
                    end
                    
                end
                
            end
        end
    end
end
% 
